package usecase

import (
	"gitlab.informatika.org/k-01-11/graduit-be/src/module/batch_seminar/entity"
)

type BatchSeminarUsecase interface {
	AddBatchSeminar(bimbinganLog entity.BatchSeminar) (entity.BatchSeminar, error)
	GetBatchSeminar() ([]entity.BatchSeminar, error)
	DeleteBatchSeminar(id string) (entity.BatchSeminar, error)
}

type BatchSeminarUc struct {
	batchSeminarRepo BatchSeminarRepository
}

func NewBatchSeminarUseCase(batchSeminarRepo BatchSeminarRepository) *BatchSeminarUc {
	return &BatchSeminarUc{
		batchSeminarRepo: batchSeminarRepo,
	}
}

func (uc *BatchSeminarUc) AddBatchSeminar(batchseminar entity.BatchSeminar) (entity.BatchSeminar, error) {
	newBatchSeminar, err := uc.batchSeminarRepo.NewBatchSeminar(batchseminar)

	if err != nil {
		return newBatchSeminar, err
	}

	return newBatchSeminar, nil

}

func (uc *BatchSeminarUc) GetBatchSeminar() ([]entity.BatchSeminar, error) {
	return uc.batchSeminarRepo.GetSeminarBatches()
}

func (uc *BatchSeminarUc) DeleteBatchSeminar(id string) (entity.BatchSeminar, error) {
	return uc.batchSeminarRepo.DeleteBatchSeminar(id)
}
