package usecase

import (
	"gitlab.informatika.org/k-01-11/graduit-be/src/module/batch_sidang/entity"
)

type BatchSidangUsecase interface {
	AddBatchSidang(bimbinganLog entity.BatchSidang) (entity.BatchSidang, error)
	GetBatchSidang() ([]entity.BatchSidang, error)
	DeleteBatchSidang(id string) (entity.BatchSidang, error)
}

type BatchSidangUc struct {
	batchSidangRepo BatchSidangRepository
}

func NewBatchSidangUseCase(batchSidangRepo BatchSidangRepository) *BatchSidangUc {
	return &BatchSidangUc{
		batchSidangRepo: batchSidangRepo,
	}
}

func (uc *BatchSidangUc) AddBatchSidang(batchSidang entity.BatchSidang) (entity.BatchSidang, error) {
	newBatchSidang, err := uc.batchSidangRepo.NewBatchSidang(batchSidang)

	if err != nil {
		return newBatchSidang, err
	}

	return newBatchSidang, nil

}

func (uc *BatchSidangUc) GetBatchSidang() ([]entity.BatchSidang, error) {
	return uc.batchSidangRepo.GetSidangBatches()
}

func (uc *BatchSidangUc) DeleteBatchSidang(id string) (entity.BatchSidang, error) {
	return uc.batchSidangRepo.DeleteBatch(id)
}
